using System;
using Gtk;
using Avahi;

public class MainApp
{
	public static void Main(string[] args)
	{
		Application.Init ();
		//TestBrowser browser = 
		new TestBrowser();
		Application.Run ();
	}
}

public class TestBrowser
{
	Avahi.Client client;
	Avahi.ServiceBrowser browser;
	Avahi.ServiceResolver resolver;

	public TestBrowser ()
	{
		client = new Avahi.Client ();

		Console.WriteLine ("Starting Service Browser");
		browser = new Avahi.ServiceBrowser (client, "_daap._tcp");
		browser.ServiceAdded += OnServiceAdded;
		browser.ServiceRemoved += OnServiceRemoved;
	}

	public void OnServiceAdded (object o, ServiceInfoArgs args)
	{
		if (args.Service.Protocol != Avahi.Protocol.IPv4)
			return;
		Console.WriteLine ("Starting Service Resolver");
		resolver = new ServiceResolver (client, args.Service);
		resolver.Found += OnServiceFound;
	}

	public void OnServiceFound (object o, ServiceInfoArgs args)
	{
		ServiceInfo Service = (ServiceInfo) args.Service;
		Console.WriteLine ("Service Found: {0} with {1}:{2}", 
				Service.Name, 
				Service.Address, Service.Port);

		Console.WriteLine ("Resolver finish.");
	}

	public void OnServiceRemoved (object o, ServiceInfoArgs args)
	{
		Console.WriteLine ("Service Removed: {0} {1}:{2}", args.Service.Name, 
				args.Service.HostName, args.Service.Port);
	}
}
