using Gtk;
using System;
using GConf.PropertyEditors;

public class MainClass
{
	public static void Main(string[] args)
	{
		Application.Init();
		
		new GuiTest("Hello GConf");
		
		Application.Run();
	}
}

public class GuiTest : Window
{
	CheckButton cb;

	const string ENABLE_SOMETHING = "/apps/testgconf/something";
	GConf.Client client;
	GConf.NotifyEventHandler changed_handler;

	public GuiTest(string title) : base(title)
	{		
		DeleteEvent += OnWindowDelete;
		
		VBox v = new VBox();
		v.BorderWidth = 6;
		
		Label l = new Label("A Simple Test\n");
		v.Add (l);

		cb = new CheckButton("Check Something");
		v.Add (cb);
		
		Init ();

		Add (v);
		DefaultWidth = 200;
		DefaultHeight = 100;
		ShowAll ();
	}
	
	private void Init()
	{
		client = new GConf.Client ();

		changed_handler = new GConf.NotifyEventHandler (OnSettingChanged);
		client.AddNotify ("/apps/testgconf", changed_handler);

		PropertyEditorBool peditor = new PropertyEditorToggleButton (ENABLE_SOMETHING, cb);
		try
		{
			client.Get (ENABLE_SOMETHING);
		}
		catch (GConf.NoSuchKeyException)
		{
			Console.WriteLine ("creating gconf entry: {0}", ENABLE_SOMETHING);
			client.Set (ENABLE_SOMETHING, false);
		}
		peditor.Setup ();
	}

	static void OnSettingChanged (object sender, GConf.NotifyEventArgs args)
	{
		Console.WriteLine ("gconf entry change: {0} = {1}", args.Key, args.Value);
	}
	
	private static void OnWindowDelete (System.Object o, DeleteEventArgs args)
	{
		Application.Quit ();
		args.RetVal = true;
	}
}
