using Gtk;
using System;
using System.IO;

public class MainClass
{
	public static void Main(string[] args)
	{
		Application.Init ();
		
		new GuiTest ("Hello TreeView");
		
		Application.Run ();
	}
}

public class GuiTest : Window
{
	ListStore  store;
	private enum TreeColumns {
		NAME,
		TIME
	}

	public GuiTest(string title) : base(title)
	{		
		DeleteEvent += OnWindowDelete;
		
		VBox v = new VBox ();
		
		ScrolledWindow sw = new ScrolledWindow ();
		v.Add (sw);

		InitListStore ();

          	TreeView tv = new TreeView (store);
		tv.AppendColumn ("Name", new CellRendererText (), "text", (int) TreeColumns.NAME);
		tv.AppendColumn ("Time", new CellRendererText (), "text", (int) TreeColumns.TIME);
		sw.Add (tv);
		
		DefaultWidth = 400;
		DefaultHeight = 400;
		Add (v);
		ShowAll ();
	}
	
	private void InitListStore ()
	{
	  store = new ListStore (typeof (string), typeof(string));

	  string[] files = Directory.GetFiles("/etc/");
	  foreach (string file in files) 
		  store.AppendValues (
				  file, 
				  File.GetLastAccessTime (file).ToString ()
				  );
	}
	
	private static void OnWindowDelete (System.Object o, DeleteEventArgs args)
	{
		Application.Quit ();
		args.RetVal = true;
	}
}
